%define baserepopath /software/ibmi/products/pase/rpms/repo-base-7.3/
%define releaserepopath /software/ibmi/products/pase/rpms/repo-$releasever/

Name: ibmi-repos
Version: %(echo `uname -v`.`uname -r`)
Release: 5
Summary: IBM i package repositories

License: MIT
URL: https://public.dhe.ibm.com/software/ibmi/products/pase/rpms
Source0: ibmi-base.repo
Source1: ibmi-release.repo
Source2: ibmi-base-unsecure.repo
Source3: ibmi-release-unsecure.repo

BuildArch: noarch

Requires: ca-certificates-mozilla
Requires(post): /QOpenSys/usr/bin/grep
Requires(post): /QOpenSys/usr/bin/sed

%description
IBM i package repository files for yum.

%install
mkdir -p %{buildroot}%{_sysconfdir}/yum/repos.d
install -m 644 %{SOURCE0} %{buildroot}%{_sysconfdir}/yum/repos.d
install -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/yum/repos.d
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/yum/repos.d
install -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/yum/repos.d


# Since the .repo files are shipped %config(noreplace), we need to manually 
# adjust the baseurl values in case the users have made changes. That is,
# if the user has modified something (for instance, skip_if_unavailable=1
# or using an IP address in the baseurl to work around DNS issues), we
# still want to be able to deliver updates to the repo locations.
#
# To accomplish this, the post-install scriptlet loops through the delivered .repo
# files and "fixes up" any URL that contains "/software/ibmi/products/" to point at
# the proper repository. This approach leaves the hostname and protocol
# portions of the URL intact, as well as any user-edited properties.
%post
cd /QOpenSys/etc/yum/repos.d
for f in ibmi-base.repo ibmi-base-unsecure.repo ; do
  echo "Fixing up URL for $f..."
  tmpf=$f.$$
  /QOpenSys/usr/bin/sed -e 's@http://\([^ ]*\)/software/ibmi/products/[^ ]*@https://\1%{baserepopath}@g' \
   -e  's@https://\([^ ]*\)/software/ibmi/products/[^ ].*@https://\1%{baserepopath}@g' \
   -e  's@ftp://\([^ ]*\)/software/ibmi/products/[^ ].*@https://\1%{baserepopath}@g' $f > $tmpf
  mv $tmpf $f
done
for f in ibmi-release.repo ibmi-release-unsecure.repo ; do
  echo "Fixing up URL for $f..."
  tmpf=$f.$$
  /QOpenSys/usr/bin/sed -e 's@http://\([^ ]*\)/software/ibmi/products/[^ ]*@https://\1%{releaserepopath}@g' \
   -e 's@https://\([^ ]*\)/software/ibmi/products/[^ ].*@https://\1%{releaserepopath}@g'  \
   -e 's@ftp://\([^ ]*\)/software/ibmi/products/[^ ].*@https://\1%{releaserepopath}@g' $f > $tmpf
  mv $tmpf $f
done

for f in ibmi-base-unsecure.repo ibmi-release-unsecure.repo ; do
  echo "Modifying 'sslverify' attribute for $f..."
  if [ "" == "$(/QOpenSys/usr/bin/grep -i sslverify $f)" ]; then
    echo "sslverify=0" >> $f
  else
    tmpf=$f.$$
    /QOpenSys/usr/bin/sed -e 's@^[ ]*sslverify[ ]*=.*$@sslverify=0@g' $f > $tmpf
    mv $tmpf $f
  fi
done

echo "Done fixing up repo files."

%files
%defattr(-, qsys, *none)
%config(noreplace) %{_sysconfdir}/yum/repos.d/ibmi-base.repo
%config(noreplace) %{_sysconfdir}/yum/repos.d/ibmi-release.repo
%config(noreplace) %{_sysconfdir}/yum/repos.d/ibmi-base-unsecure.repo
%config(noreplace) %{_sysconfdir}/yum/repos.d/ibmi-release-unsecure.repo

%changelog
* Thu Mar 09 2023 Jesse Gorzinski <jgorzins@us.ibm.com>
- IBM repos now use https only (no ftp or http)

* Wed Aug 03 2022 Kevin Adler <kadler@us.ibm.com>
- Fix inconsistent trailing slash in repo URLs

* Tue Jul 19 2022 Jesse Gorzinski <jgorzins@us.ibm.com>
- Add "unsecure" repositories, disabled by default
- Require ca-certificates-mozilla
- Fix up user-modified repo definitions to use proper repo

* Wed Jun 15 2022 Abdirahim Musse <abdirahim.musse@ibm.com>
- Update base repo to repo-base-7.3

* Fri Nov 13 2020 Abdirahim Musse <abdirahim.musse@ibm.com>
- Initial spec
